// -*- mode: c++ -*-
// 
// File MDF.C generated by TMultiDimFit::MakeRealCode
// on Tue Dec 16 22:21:33 2008
// ROOT version 5.21/07
//
// This file contains the function 
//
//    double  MDF(double *x); 
//
// For evaluating the parameterization obtained
// from TMultiDimFit and the point x
// 
// See TMultiDimFit class documentation for more information 
// 
//
// Static data variables
//
static int    gNVariables    = 4;
static int    gNCoefficients = 21;
static double gDMean         = 48.4044;
// Assignment to mean vector.
static double gXMean[] = {
  0.00657672, 0.0083759, -0.00385446, 0.000527764 };

// Assignment to minimum vector.
static double gXMin[] = {
  0.0454982, 0.0152285, 0.0410935, 0.00381892 };

// Assignment to maximum vector.
static double gXMax[] = {
  9.95437, 9.98965, 9.99761, 9.99454 };

// Assignment to coefficients vector.
static double gCoefficient[] = {
  -4.37056,
  43.1468,
  13.432,
  13.4632,
  13.3964,
  13.328,
  13.3016,
  13.3519,
  4.49724,
  4.63876,
  4.89036,
  -3.69982,
  -3.98618,
  -3.86195,
  4.36054,
  -4.02597,
  4.57037,
  4.69845,
  2.83819,
  -3.48855,
  -3.97612
 };

// Assignment to error coefficients vector.
static double gCoefficientRMS[] = {
  0.087983,
  0.160068,
  0.0803202,
  0.0780501,
  0.0805407,
  0.142335,
  0.136729,
  0.133101,
  0.151057,
  0.158524,
  0.164018,
  0.136418,
  0.143801,
  0.145772,
  0.261394,
  0.255538,
  0.247735,
  0.272897,
  0.25246,
  0.229248,
  0.256589
 };

// Assignment to powers vector.
// The powers are stored row-wise, that is
//  p_ij = gPower[i * NVariables + j];
static int    gPower[] = {
  1,  1,  1,  1,
  2,  1,  1,  1,
  1,  1,  1,  2,
  1,  1,  2,  1,
  1,  2,  1,  1,
  2,  2,  1,  1,
  2,  1,  1,  2,
  2,  1,  2,  1,
  1,  1,  1,  3,
  1,  3,  1,  1,
  1,  1,  5,  1,
  1,  1,  2,  2,
  1,  2,  1,  2,
  1,  2,  2,  1,
  2,  1,  1,  3,
  2,  2,  1,  2,
  2,  1,  3,  1,
  2,  3,  1,  1,
  1,  2,  2,  2,
  2,  1,  2,  2,
  2,  2,  2,  1
};

// 
// The function   double MDF(double *x)
// 
double MDF(double *x) {
  double returnValue = gDMean;
  int    i = 0, j = 0, k = 0;
  for (i = 0; i < gNCoefficients ; i++) {
    // Evaluate the ith term in the expansion
    double term = gCoefficient[i];
    for (j = 0; j < gNVariables; j++) {
      // Evaluate the polynomial in the jth variable.
      int power = gPower[gNVariables * i + j]; 
      double p1 = 1, p2 = 0, p3 = 0, r = 0;
      double v =  1 + 2. / (gXMax[j] - gXMin[j]) * (x[j] - gXMax[j]);
      // what is the power to use!
      switch(power) {
      case 1: r = 1; break; 
      case 2: r = v; break; 
      default: 
        p2 = v; 
        for (k = 3; k <= power; k++) { 
          p3 = p2 * v;
          p1 = p2; p2 = p3; 
        }
        r = p3;
      }
      // multiply this term by the poly in the jth var
      term *= r; 
    }
    // Add this term to the final result
    returnValue += term;
  }
  return returnValue;
}

// EOF for MDF.C
